<template>
  <div class="gameManger-page">
    <a-table :columns="columns" :data-source="columnsData" :loading="loading" rowKey="game_id">
      <span slot="website" slot-scope="text, record"><a :href="record.website" target="_blank">{{ record.website }}</a></span>
      <span slot="public" slot-scope="text, record">{{ record.cust_public == 1 ? '公开' : '私密' }}</span>
      <template slot="checked" slot-scope="text, record">
        <a-tooltip v-if="record.checked==2" :title="record.cust_reason">
          <a-tag color="red">未通过</a-tag>
          <a-icon type="question-circle" theme="filled" />
        </a-tooltip>
        <a-tag v-else-if="record.checked==1" color="green">已通过</a-tag>
        <a-tag v-else color="orange">待审核</a-tag>
      </template>
      <template slot="operation" slot-scope="text, record, index">
        <a class="operation" v-if="record.checked==0" @click="handleCheck(record)">审核</a>
        <a class="operation" v-else style="color: #ff3434" @click="handleDelete(record, index)">删除</a>
      </template>
    </a-table>
    <a-modal v-model="checkVisible"
             title="审核"
             destroyOnClose
             :confirmLoading="saveLoading"
             :afterClose="() => $refs.check.resetFields()"
             @ok="handleCheckOk">
      <a-form-model
          ref="check"
          :model="formCheck"
          :rules="formCheckRules"
      >
        <a-form-model-item prop="checked">
          <a-radio-group v-model="formCheck.checked">
            <a-radio value="1">通过</a-radio>
            <a-radio value="2">不通过</a-radio>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item v-if="formCheck.checked === '2'" prop="cust_reason">
          <a-textarea v-model="formCheck.cust_reason" placeholder="请输入原因" :rows="4"/>
        </a-form-model-item>
      </a-form-model>
    </a-modal>
    <a-modal v-model="editVisible"
             title="编辑赛事信息"
             destroyOnClose
             :confirmLoading="saveLoading"
             :afterClose="() => $refs.edit.resetFields()"
             @ok="handleEditOk">
      <a-form-model ref="edit"
                    :model="formEdit"
                    :rules="formEditRules"
                    :label-col="labelCol"
                    :wrapper-col="wrapperCol">
        <a-form-model-item label="比赛名称" prop="game_name">
          <a-input v-model="formEdit.game_name" allowClear placeholder="请输入比赛名称"/>
        </a-form-model-item>
        <a-form-model-item label="起止时间" prop="cust_game_time">
          <a-range-picker
              v-model="formEdit.cust_game_time"
              :disabled-date="disabledDate"
              :show-time="{
                hideDisabledOptions: true,
                defaultValue: [$moment('00:00:00', 'HH:mm:ss'), $moment('11:59:59', 'HH:mm:ss')]
              }"
              format="YYYY-MM-DD HH:mm:ss"/>
        </a-form-model-item>
        <a-form-model-item label="比赛链接" prop="website">
          <a-input v-model="formEdit.website" placeholder="请输入比赛链接"/>
        </a-form-model-item>
        <a-form-model-item label="举办方" prop="platform">
          <a-select v-model="formEdit.platform" placeholder="请选择">
            <a-select-option value="codeforces">codeforces</a-select-option>
            <a-select-option value="atcoder">atcoder</a-select-option>
            <a-select-option value="力扣">力扣</a-select-option>
            <a-select-option value="牛客网">牛客网</a-select-option>
            <a-select-option value="洛谷">洛谷</a-select-option>
            <a-select-option value="自定义">自定义</a-select-option>
          </a-select>
        </a-form-model-item>
        <a-form-model-item label="难度" prop="level">
          <a-radio-group v-model="formEdit.level">
            <a-radio :value="1">简单</a-radio>
            <a-radio :value="2">中等</a-radio>
            <a-radio :value="3">困难</a-radio>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item label="是否公开" prop="cust_public">
          <a-switch v-model="formEdit.cust_public"></a-switch>
        </a-form-model-item>
      </a-form-model>
    </a-modal>
  </div>
</template>

<script>
export default {
  name: "gameManger",

  data() {
    let validateReason = (rule, value, callback) => {
      if (this.formCheck.checked !== '2') return callback();
      if (!value) {
        return callback(new Error('请输入原因'));
      } else {
        callback()
      }
    }
    return {
      labelCol: {span: 4},
      wrapperCol: {span: 14},
      columns: [
        {
          title: '比赛名',
          dataIndex: 'game_name',
          key: 'game_name',
          width: '15%',

        },
        {
          title: '开始时间',
          dataIndex: 'game_start_time',
          key: 'game_start_time',
          width: '15%',
        },
        {
          title: '结束时间',
          dataIndex: 'game_end_time',
          key: 'game_end_time',
          width: '15%',
        },
        {
          title: '比赛链接',
          dataIndex: 'website',
          key: 'website',
          width: '250px',
          scopedSlots: {customRender: 'website'},
        },
        {
          title: '举办方',
          dataIndex: 'platform',
          key: 'platform',
          width: '8%',
        },
        {
          title: '公开状态',
          dataIndex: 'cust_public',
          key: 'cust_public',
          width: '90px',
          scopedSlots: {customRender: 'public'},
        },
        {
          title: '审核状态',
          dataIndex: 'checked',
          key: 'checked',
          width: '120px',
          scopedSlots: {customRender: 'checked'},
        },
        {
          title: '操作',
          key: 'operation',
          width: '130px',
          scopedSlots: {customRender: 'operation'},
        },
      ],
      columnsData: [],
      loading: false,
      formCheck: {
        checked: '',
        cust_reason: ''
      },
      formCheckRules: {
        checked: [{required: true, message: '请选择审核状态', trigger: 'blur'}],
        cust_reason: [{validator: validateReason, trigger: 'blur'}]
      },
      formEdit: {
        game_name: '',
        cust_game_time: [],
        website: '',
        platform: '',
        level: '',
        cust_public: ''
      },
      formEditRules: {
        game_name: [{required: true, message: '请输入比赛名称', trigger: 'blur'}],
        cust_game_time: [{required: true, message: '请选择起止时间', trigger: 'blur'}],
        website: [{required: true, message: '请输入比赛链接', trigger: 'blur'}],
        platform: [{required: true, message: '请选择举办方', trigger: 'blur'}],
        level: [{required: true, message: '请选择难度', trigger: 'blur'}],
        cust_public: [{required: true, message: '', trigger: 'blur'}]
      },
      checkVisible: false,
      editVisible: false,
      saveLoading: false,
      game_id: ''
    }
  },

  created() {
    this.getList()
  },

  methods: {
    disabledDate(current) {
      return current && current < this.$moment().endOf('day');
    },
    async getList() {
      this.loading = true
      await this.$axios.get('game/custom/query/all').then(res => {
        if (res.code == undefined) {
          this.columnsData = res
        }
      }).catch(() => {
      })
      this.loading = false
    },

    handleCheck(record) {
      this.game_id = record.game_id
      this.checkVisible = true
    },

    handleCheckOk() {
      this.$refs.check.validate(async valid => {
        if (valid) {
          this.saveLoading = true
          await this.$axios.post('game/check', {
            checked: this.formCheck.checked,
            cust_reason: this.formCheck.checked === '2' ? this.formCheck.cust_reason : undefined,
            game_id: this.game_id
          }).then(res => {
            if (res.code == 0) {
              this.checkVisible = false
              this.getList()
            } else {
              this.$notification.error({message: '操作失败'})
            }
          }).catch(() => {
            this.$notification.error({message: '操作失败'})
          })
          this.saveLoading = false
        }
      })
    },

    handleEdit(record) {
      this.editVisible = true
      this.game_id = record.game_id
      this.formEdit = {
        game_name: record.game_name,
        cust_game_time: [record.game_start_time, record.game_end_time],
        website: record.website,
        platform: record.platform,
        level: record.level,
        cust_public: record.cust_public == 1
      }
    },

    handleEditOk() {
      this.$refs.edit.validate( async valid => {
        if (valid) {
          let params = {}
          params.game_name = this.formEdit.game_name
          params.game_start_time = this.$moment(this.formEdit.cust_game_time[0]).format('yyyy-MM-DD HH:mm:ss')
          params.game_end_time = this.$moment(this.formEdit.cust_game_time[1]).format('yyyy-MM-DD HH:mm:ss')
          params.website = this.formEdit.website
          params.platform = this.formEdit.platform
          params.level = this.formEdit.level
          params.cust_public = this.formEdit.cust_public ? 1 : 0
          params.game_id = this.game_id
          this.saveLoading = true
          await this.$axios.post('game/update', params).then(res => {
            if (res.code == 0) {
              this.editVisible = false
              this.getList()
            } else {
              this.$notification.error({message: '更新失败'})
            }
          }).catch(() => {
            this.$notification.error({message: '更新失败'})
          })
          this.saveLoading = false
        }
      })
    },

    handleDelete(record, index) {
      this.$axios.post('game/delete', {
        game_id: record.game_id
      }).then(res => {
        if (res.code == 0) {
          this.$notification.success({message: '已删除'})
          this.columnsData.splice(index, 1)
        } else {
          this.$notification.error({message: '删除失败'})
        }
      }).catch(() => {
        this.$notification.error({message: '删除失败'})
      })
    }
  }
}
</script>

<style lang="less" scoped>
.gameManger-page {
  .operation {
    margin: 0 10px;
  }
}
</style>